/// <reference types="react" />
import * as React from 'react';
import * as actions from 'redux-forms/actions';
export interface IFormProps extends React.HTMLProps<HTMLFormElement> {
    name: string;
    persistent?: boolean;
    onSubmit?: (values: any) => Promise<any> | null | undefined;
    withRef?: (el: HTMLFormElement) => void;
}
export declare type Context = {
    reduxForms: string;
};
export declare type StateProps = {
    _form: boolean;
    _values: any;
    _valid: boolean;
    _submitting: boolean;
};
export declare type ActionProps = {
    _addForm: typeof actions.addForm;
    _removeForm: typeof actions.removeForm;
    _touchAll: typeof actions.touchAll;
    _submitStart: typeof actions.submitStart;
    _submitStop: typeof actions.submitStop;
};
export declare type Props = StateProps & ActionProps & IFormProps;
declare const Connected: React.ComponentClass<Pick<StateProps & ActionProps, never> & IFormProps>;
export default Connected;
