'use strict';

exports.__esModule = true;

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

exports.default = connectField;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _helpers = require('redux-forms/lib/shared/helpers');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function connectField(Wrapped) {
    var ConnectedField = function ConnectedField(props, _ref) {
        var reduxForms = _ref.reduxForms;

        var contextForm = (0, _helpers.isString)(reduxForms) ? reduxForms : null;
        var form = (0, _helpers.isString)(props.form) ? props.form : contextForm;
        (0, _helpers.invariant)((0, _helpers.isString)(form), '[redux-forms] "field(...)" and "fieldArray(...)" must be a child of the Form ' + 'component or an explicit "form" prop must be supplied.');
        return React.createElement(Wrapped, (0, _merge2.default)(props, {
            _form: form
        }));
    };
    ConnectedField.contextTypes = {
        reduxForms: PropTypes.string
    };
    ConnectedField.displayName = Wrapped.displayName;
    ConnectedField.WrappedComponent = Wrapped;
    return ConnectedField;
}