/// <reference types="react" />
import * as React from 'react';
import { InputProps, MetaProps } from 'redux-forms/lib/shared/fieldProps';
import { SuppliedProps } from './connectField';
export declare type SuppliedProps = {
    input: InputProps;
    meta: MetaProps;
};
export declare type Validate = (value: any) => string | null;
export declare type Normalize = (value: any) => any;
export declare type FieldProps = {
    name: string;
    normalize?: Normalize;
    defaultValue?: any;
    validate?: Validate;
};
declare function field<T>(Component: React.ComponentType<T & SuppliedProps>): React.ComponentType<T & FieldProps>;
export default field;
