'use strict';

exports.__esModule = true;

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _identity = require('ramda/src/identity');

var _identity2 = _interopRequireDefault(_identity);

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _lensProp = require('ramda/src/lensProp');

var _lensProp2 = _interopRequireDefault(_lensProp);

var _set = require('ramda/src/set');

var _set2 = _interopRequireDefault(_set);

var _compose = require('ramda/src/compose');

var _compose2 = _interopRequireDefault(_compose);

var _not = require('ramda/src/not');

var _not2 = _interopRequireDefault(_not);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _reactRedux = require('react-redux');

var _containers = require('redux-forms/lib/containers');

var containers = _interopRequireWildcard(_containers);

var _fieldProps2 = require('redux-forms/lib/shared/fieldProps');

var _fieldProps3 = _interopRequireDefault(_fieldProps2);

var _getValue = require('redux-forms/lib/shared/getValue');

var _getValue2 = _interopRequireDefault(_getValue);

var _helpers = require('redux-forms/lib/shared/helpers');

var _actions = require('redux-forms/actions');

var actions = _interopRequireWildcard(_actions);

var _connectField = require('./connectField');

var _connectField2 = _interopRequireDefault(_connectField);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function field(Component) {
    var Field = function (_React$Component) {
        _inherits(Field, _React$Component);

        function Field(props) {
            _classCallCheck(this, Field);

            var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

            _this.handleChange = _this.handleChange.bind(_this);
            _this.handleFocus = _this.handleFocus.bind(_this);
            _this.handleBlur = _this.handleBlur.bind(_this);
            return _this;
        }

        Field.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
            var _field = this.props._field;

            if (!(0, _helpers.shallowCompare)((0, _fieldProps2.boolField)(this.props), (0, _fieldProps2.boolField)(nextProps))) {
                return true;
            }
            return (0, _not2.default)(_field && nextProps._field && (0, _helpers.shallowCompare)(_field, nextProps._field));
        };

        Field.prototype.componentWillMount = function componentWillMount() {
            if (!this.props._field) {
                this.newField(this.props);
            }
        };

        Field.prototype.componentWillReceiveProps = function componentWillReceiveProps(next) {
            var _props = this.props,
                _fieldChange = _props._fieldChange,
                _form = _props._form,
                name = _props.name,
                defaultValue = _props.defaultValue;

            if (!next._field) {
                this.newField(next);
                return;
            }
            if (defaultValue !== next.defaultValue) {
                var value = next.normalize(next._field.value);
                var error = next.validate ? next.validate(value) : next._field.error;
                var dirty = next.defaultValue !== value;
                _fieldChange(_form, name, value, error, dirty);
            }
        };

        Field.prototype.newField = function newField(props) {
            var value = props.normalize(props.defaultValue);
            var newField = (0, _compose2.default)((0, _set2.default)((0, _lensProp2.default)('value'), value), (0, _set2.default)((0, _lensProp2.default)('error'), props.validate ? props.validate(value) : null))(containers.field);
            props._addField(props._form, props.name, newField);
        };

        Field.prototype.handleChange = function handleChange(ev) {
            var _props2 = this.props,
                _fieldChange = _props2._fieldChange,
                _form = _props2._form,
                _field = _props2._field,
                name = _props2.name,
                normalize = _props2.normalize,
                validate = _props2.validate,
                defaultValue = _props2.defaultValue;

            if (!_field) {
                return;
            }
            var value = normalize((0, _getValue2.default)(ev));
            var error = validate ? validate(value) : _field.error;
            var dirty = value !== defaultValue;
            _fieldChange(_form, name, value, error, dirty);
        };

        Field.prototype.handleFocus = function handleFocus() {
            var _props3 = this.props,
                _fieldFocus = _props3._fieldFocus,
                _form = _props3._form,
                name = _props3.name;

            _fieldFocus(_form, name);
        };

        Field.prototype.handleBlur = function handleBlur(ev) {
            var _props4 = this.props,
                _fieldBlur = _props4._fieldBlur,
                _form = _props4._form,
                _field = _props4._field,
                name = _props4.name,
                normalize = _props4.normalize,
                validate = _props4.validate,
                defaultValue = _props4.defaultValue;

            if (!_field) {
                return;
            }
            var value = normalize((0, _getValue2.default)(ev));
            var error = validate ? validate(value) : _field.error;
            var dirty = value !== defaultValue;
            _fieldBlur(_form, name, value, error, dirty);
        };

        Field.prototype.render = function render() {
            var _props5 = this.props,
                name = _props5.name,
                _field = _props5._field;
            // Wait until field is initialized

            if (!_field) {
                return null;
            }
            var inputProps = (0, _merge2.default)(_field, {
                name: name,
                onChange: this.handleChange,
                onFocus: this.handleFocus,
                onBlur: this.handleBlur
            });

            var _fieldProps = (0, _fieldProps3.default)((0, _merge2.default)(inputProps, this.props)),
                input = _fieldProps.input,
                meta = _fieldProps.meta,
                rest = _fieldProps.rest;
            // TODO SFC not compatibile with class... wtf TS


            return React.createElement(Component, (0, _merge2.default)(rest, {
                input: input,
                meta: meta
            }));
        };

        return Field;
    }(React.Component);

    Field.defaultProps = {
        normalize: _identity2.default,
        defaultValue: ''
    };
    Field.propTypes = {
        name: PropTypes.string.isRequired,
        normalize: PropTypes.func.isRequired,
        defaultValue: PropTypes.any.isRequired,
        validate: PropTypes.func
    };
    var connector = (0, _reactRedux.connect)(function (state, props) {
        return {
            _field: (0, _path2.default)([props._form, 'fields', props.name], state.reduxForms)
        };
    }, {
        _addField: actions.addField,
        _fieldChange: actions.fieldChange,
        _fieldFocus: actions.fieldFocus,
        _fieldBlur: actions.fieldBlur
    });
    // TODO SFC not compatibile with class... wtf TS
    var Connected = connector(Field);
    var Contexted = (0, _connectField2.default)(Connected);
    Contexted.displayName = 'field(' + (Component.displayName || 'Component') + ')';
    return Contexted;
}
exports.default = field;