/// <reference types="react" />
import * as React from 'react';
import { SuppliedProps } from './connectField';
export declare type SuppliedProps = {
    fields: {
        length: number;
        map: <T>(fn: (el: string, index: number) => T) => T[];
        push: () => void;
        pop: () => void;
        unshift: () => void;
        shift: () => void;
        insert: (index: number) => void;
        remove: (index: number) => void;
        swap: (index1: number, index2: number) => void;
        move: (from: number, to: number) => void;
    };
};
export declare type FieldArrayProps = {
    name: string;
};
declare function fieldArray<T>(Component: React.ComponentType<T & SuppliedProps>): React.ComponentType<T & FieldArrayProps>;
export default fieldArray;
